net.sourceforge.pmd.lang.rule.stat

## Interface StatisticalRule

All Superinterfaces:
  PropertySource, Rule

All Known Implementing Classes:
  AbstractNcssCountRule, AbstractStatisticalJavaRule, ExcessiveClassLengthRule, ExcessiveImportsRule, ExcessiveLengthRule, ExcessiveMethodLengthRule, ExcessiveNodeCountRule, ExcessiveParameterListRule, ExcessivePublicCountRule, NcssConstructorCountRule, NcssMethodCountRule, NcssTypeCountRule, NPathComplexityRule, SwitchDensityRule

    public interface StatisticalRule
    extends Rule

This interface tags a Rule as being a Statistical rule, producing various metrics from data points.

See Also:
  `DataPoint`, `Metric`, `StatisticalRuleHelper`

### Field Summary

Fields
`static DoubleProperty` `MINIMUM_DESCRIPTOR`
`static DoubleProperty` `SIGMA_DESCRIPTOR`
`static IntegerProperty` `TOP_SCORE_DESCRIPTOR`

### Fields inherited from interface net.sourceforge.pmd.Rule

`VIOLATION_SUPPRESS_REGEX_DESCRIPTOR, VIOLATION_SUPPRESS_XPATH_DESCRIPTOR`

### Method Summary

Methods
`void` `addDataPoint(DataPoint point)`
`Object[]` `getViolationParameters(DataPoint point)`

### Methods inherited from interface net.sourceforge.pmd.Rule

`addExample, addRuleChainVisit, addRuleChainVisit, apply, end, getDescription, getExamples, getExternalInfoUrl, getLanguage, getMaximumLanguageVersion, getMessage, getMinimumLanguageVersion, getName, getParserOptions, getPriority, getRuleChainVisits, getRuleClass, getRuleSetName, getSince, isDeprecated, setDeprecated, setDescription, setExternalInfoUrl, setLanguage, setMaximumLanguageVersion, setMessage, setMinimumLanguageVersion, setName, setPriority, setRuleClass, setRuleSetName, setSince, setUsesDFA, setUsesTypeResolution, start, usesDFA, usesRuleChain, usesTypeResolution`

### Methods inherited from interface net.sourceforge.pmd.PropertySource

`definePropertyDescriptor, dysfunctionReason, getPropertiesByPropertyDescriptor, getProperty, getPropertyDescriptor, getPropertyDescriptors, hasDescriptor, ignoredProperties, setProperty, useDefaultValueFor, usesDefaultValues`

### Field Detail

#### SIGMA_DESCRIPTOR

    static final DoubleProperty SIGMA_DESCRIPTOR

#### MINIMUM_DESCRIPTOR

    static final DoubleProperty MINIMUM_DESCRIPTOR

#### TOP_SCORE_DESCRIPTOR

    static final IntegerProperty TOP_SCORE_DESCRIPTOR

### Method Detail

#### addDataPoint

    void addDataPoint(DataPoint point)

#### getViolationParameters

    Object[] getViolationParameters(DataPoint point)